;CAD Ideas Set layer program
;this program consists of 4 lisp routines
;these routines may not be altered or used separately
;without writtin permission of ED Azoyan
;Copyright (C) Ed Azoyan and CAD IDEAS Inc. 1988
(prompt "\nInitial load of CAD Ideas Lisp Routine (C) Copyright Ed Azoyan. ")
(vmon)
;;;;;;;;;;;;;;;;;;;; defun cderr is a error handeler
;;;;;;;;;;;;;;;;;;;;
(defun cderr (msg) 
	(if (/= msg "Function cancelled")
		(princ (strcat "\nError: " msg))
	)
	(redraw)
	(grtext)
	(setvar "blipmode" sblip) 
	(setvar "cmdecho" scmde)
	(setq *error* exerr)
	(prin1)
)
;;;;;;;;;;;;;;;;;;;; defun strp is a function for prompting  layer information
;;;;;;;;;;;;;;;;;;;;
(defun strp (a / b c d e f d1)
	(setq b (tblsearch "layer" a)
		c (cdr(assoc 2 b))
		d (cdr(assoc 62 b))
		e (cdr(assoc 6 b))
		f (cdr(assoc 70 b))
	)
	(if (<= (strlen c) 15)
		(progn
			(cond
				((= (strlen c) 1) (setq c (strcat c "              ")))
				((= (strlen c) 2) (setq c (strcat c "             ")))
				((= (strlen c) 3) (setq c (strcat c "            ")))
				((= (strlen c) 4) (setq c (strcat c "           ")))
				((= (strlen c) 5) (setq c (strcat c "          ")))
				((= (strlen c) 6) (setq c (strcat c "         ")))
				((= (strlen c) 7) (setq c (strcat c "        ")))
				((= (strlen c) 8) (setq c (strcat c "       ")))
				((= (strlen c) 9) (setq c (strcat c "      ")))
				((= (strlen c) 10) (setq c (strcat c "     ")))
				((= (strlen c) 11) (setq c (strcat c "    ")))
				((= (strlen c) 12) (setq c (strcat c "   ")))
				((= (strlen c) 13) (setq c (strcat c "  ")))
				((= (strlen c) 14) (setq c (strcat c " ")))
				((= (strlen c) 15) (setq c c))
			)
		)
		(setq c (substr c 1 15))
	)
				
	(if (minusp d)
		(progn
			(setq d1 "OFF"
				d (- d)
			)
		)
		(setq d1 "ON ")
	)
	(if (and (> d 0) (<= d 7))
		(progn
			(cond
				((= d 1) (setq d "  1 - Red     "))
				((= d 2) (setq d "  2 - Yellow  "))
				((= d 3) (setq d "  3 - Green   "))
				((= d 4) (setq d "  4 - Cyan    "))
				((= d 5) (setq d "  5 - Blue    "))
				((= d 6) (setq d "  6 - Magenta "))
				((= d 7) (setq d "  7 - White   "))
			)
		)
		(progn
			(setq d (itoa d))
			(cond
				((= (strlen d) 1) (setq d(strcat "  " d "           ")))
				((= (strlen d) 2) (setq d(strcat " " d "           ")))
				((= (strlen d) 3) (setq d(strcat d "           ")))
			)
		)
	)
	(if (or (= f 1) (= f 65))
		(setq f "Frozen")
		(setq f "Thawed")
	)
	
	(prompt "\n -Layer Name-   -On/Off-  -Color-      -Frz/Thw-  -LineType-  ")
	(prompt (strcat "\n" c "   " d1 "   " d "  " f "     " e))
)				
;;;;;;;;;;;;;;;;;;;; defun lrwrk is the function for picking layers from the
;;;;;;;;;;;;;;;;;;;;	screen menu area of autocad
;;;;;;;;;;;;;;;;;;;;
(defun lrwrk (/ mpn nobt iobt sibt swch swcha lnobt loup mmc)
	(setq mpn 0
		nobt (list "0" " " "NEXT")
		iobt (list " " "NEXT")
		sibt (tblnext "LAYER" T)
		iobt (cons sibt iobt)
		sibt (tblnext "LAYER")
		swch "OFF"
	)
	(if sibt
		(progn
			(grtext mpn "CADIDEAS")
			(setq mpn 1)
			(grtext mpn " CANCEL ")
			(repeat 19
				(setq mpn (1+ mpn))
				(grtext mpn " ")
			)
			(setq mpn 1
				mpn (1+ mpn)
			)
			(grtext mpn (nth 0 nobt))
			(while sibt
				(setq mpn (1+ mpn))
				(grtext mpn (cdr (assoc 2 sibt)))
				(setq nobt (cons (cdr (assoc 2 sibt))nobt)
					iobt (cons sibt iobt)
					lnobt (length nobt)
					sibt (tblnext "LAYER")
				)
				(cond ((not sibt)
					(while (< mpn 18)
						(setq mpn (1+ mpn))
						(grtext mpn " ")
					)
				      )
				)
				(cond ((and (= lnobt 17) sibt) 
					(while (< mpn 18)				
						(setq mpn (1+ mpn))
						(grtext mpn (nth (- mpn 2) nobt))
					)
				      )
				)
				(cond (( >= mpn 16)
					(setq loup T)
					(while loup
						(grtext 19 (strcat "LOOK=" swch))
						(grtext 20 swch1)
						(if sibt
							(prompt (strcat "\nPick the Layer to " swch1 " from the menu, or NEXT:"))
							(prompt (strcat "\nPick the LAYER to " swch1 " from the menu:"))
						)
						(setq mmc (grread))
						(if (or 
							    (and (= (car mmc) 4)
							    	 (= (cadr mmc) 19)
							    )
							    (and (= (car mmc) 4)
							    	 (= (cadr mmc) 20)
							    )
							    (and (= (car mmc) 4)
							    	 (not sibt) 
								 (>= (cadr mmc) 1) 
								 (< (cadr mmc) lnobt)
							    ) 
							    (and (= (car mmc) 4)
							    	 sibt
							         (>= (cadr mmc) 1)
							         (/= (cadr mmc) 17)
							         (<= (cadr mmc) (1+ lnobt))
							    )
						    )
						    	(progn
								(setq mmc (cadr mmc))
								(if (= mmc 19)
									(progn
										(if (equal swch "OFF")
											(setq swch " ON")
											(setq swch "OFF")
										)
									)
									(progn
										(if (= mmc 20)
											(progn
												(if (equal swch1 "SET")
													(setq swch1 "ON/OFF")
													(progn
														(if (equal swch1 "ON/OFF")
															(setq swch1 "FRZ/THW")
															(setq swch1 "SET")
														)
													)
												)
											)
											(progn
												(if (and (/= mmc 1) (/= mmc 18))
													(progn
														(cond ((equal swch1 "SET") (setq swcha "SET"))
														      ((equal swch1 "ON/OFF") 
														       	(if (minusp (cdr(assoc 62 (tblsearch "layer" (nth (- lnobt (1+ mmc))nobt)))))
														       		(setq swcha "ON")
														       		(setq swcha "OFF")
														       	)
														      )
														      ((equal swch1 "FRZ/THW")
														      	(if (or	
																(= (cdr(assoc 70 (tblsearch "layer" (nth (- lnobt (1+ mmc))nobt)))) 1)
																(= (cdr(assoc 70 (tblsearch "layer" (nth (- lnobt (1+ mmc))nobt)))) 65)
															    )
																(setq swcha "THAW")
																(setq swcha "FREEZE")
															)
														      )
														)   
														(if(and	(equal swcha "OFF") 
															(equal (getvar "CLAYER") (nth (- lnobt (1+ mmc))nobt))
														   ) 
															(progn
																(prompt "\nYou are turning off the current layer.....")
																(command "LAYER" swcha (nth (- lnobt (1+ mmc))nobt) "Y" "")
																(prompt "\nThe current layer has been turned off......")
																(strp (nth (- lnobt (1+ mmc))nobt))
															)
															(progn
																(if(and (equal swcha "FREEZE") 
																	(equal (getvar "CLAYER") (nth (- lnobt (1+ mmc))nobt))
																   ) 
																	(progn
																	(prompt "\nCan not FREEZE the current layer.")
																	(strp (nth (- lnobt (1+ mmc))nobt))
																	)
																		(progn
																			(if (and (equal swcha "SET")
																				(or
																					(= (cdr(assoc 70 (tblsearch "layer" (nth (- lnobt (1+ mmc))nobt)))) 1)
																					(= (cdr(assoc 70 (tblsearch "layer" (nth (- lnobt (1+ mmc))nobt)))) 65)
																				)
																			    )
																			    	(progn
																			    	(prompt "\nThis layer is FROZEN...and Can't be current until Thawed..")
																			    	(strp (nth (- lnobt (1+ mmc))nobt))
																			    	)
																			    	(progn
																				(command "LAYER" swcha (nth (- lnobt (1+ mmc))nobt) "")
																				(strp (nth (- lnobt (1+ mmc))nobt))
																				)
																			)
																		)
																)
															)
														)
														(cond ((equal swch "OFF")
															(setq loup nil 
																sibt nil
															)
						      								      )
														)
													)
													(progn
														(if (= mmc 1)
															(progn
																(setq sibt nil)
																(setq loup nil)
																(prompt "\n\nLISP ROUTINE CANCELED.\n")
															)
															(progn
																(setq loup nil
																nobt (list " " "NEXT")
																iobt (list " " "NEXT")
																mpn 1
																)
															)
														)
													)
												)
											)
										)
									)
								)
							)
							(progn
								(if sibt
									(prompt "\n\nYou Must pick a LAYER or the word NEXT from the menu,  Please try again.\n\n")
									(prompt "\n\nYou Must pick a LAYER from the menu,  Please try again.\n\n")
								)
							)
						)
					)
				      )
				)
			)
		)
		(Prompt "\n\nOnly Layer ( 0 ) was found.\n")
	)
)
;;;;;;;;;;;;;;;;;;;;; defun C:SLAYR is the new set layer command for autocad
;;;;;;;;;;;;;;;;;;;;;
(defun C:SLAYR (/ exerr sblip scmde ttx stx lrsi)
	(setq exerr *error*
		*error* cderr
		sblip (getvar "blipmode")
		scmde (getvar "cmdecho")
		ttx (list 2 32)
	)
	(if swch1
		(setq swch1 swch1)
		(setq swch1 "SET")
	)
	(setvar "blipmode" 0) 
	(setvar "cmdecho" 0)
	(while (and (= (car ttx)2) (= (cadr ttx) 32))
		(cond ((equal swch1 "SET")
			(setq stx "SET")
			(prompt "\nSpace to Toggle or <To Pick an Entity on the layer to SET>: ")
			)
			((equal swch1 "ON/OFF")
				(setq stx "turn OFF")
				(prompt "\nSpace to Toggle or <To Pick an Entity on the layer to turn OFF>: ")
			)
			((equal swch1 "FRZ/THW")
				(setq stx "FREEZE")
				(prompt "\nSpace to Toggle or <To Pick an Entity on the layer to FREEZE>: ")
			)
		)
		(setq ttx (grread))
		(if (or (and (= (car ttx) 2)(= (cadr ttx )13))
			(and (= (car ttx)6) (= (cadr ttx) 0))
			)
			(setq ttx ())
			(cond((and (= (car ttx)2) (= (cadr ttx) 32))
				(if (equal swch1 "SET")
					(setq swch1 "ON/OFF")
					(if (equal swch1 "ON/OFF")
						(setq swch1 "FRZ/THW")
						(setq swch1 "SET")
					)
				)
				)
			)
		)
	)
	(setq lrsi(entsel(strcat "\nPick an Entity on the layer to " stx ", or <LIST>: ")))
	(if lrsi
		(cond((equal swch1 "SET")
			(command "LAYER" "S" (cdr (assoc 8(entget(car lrsi)))) "")
			(strp (cdr(assoc 8(entget(car lrsi)))))
			)
			((equal swch1 "ON/OFF")
				(if (equal (getvar "CLAYER") (cdr (assoc 8(entget(car lrsi)))))
					(progn
						(command "LAYER" "OFF" (cdr (assoc 8(entget(car lrsi)))) "Y" "")
						(strp (cdr(assoc 8(entget(car lrsi)))))
					)
					(progn
						(command "LAYER" "OFF" (cdr (assoc 8(entget(car lrsi)))) "")
						(strp (cdr(assoc 8(entget(car lrsi)))))
					)
				)
			)
			((equal swch1 "FRZ/THW")
				(if (equal (getvar "CLAYER") (cdr (assoc 8(entget(car lrsi)))))
					(prompt "\nCan Not FREEZE the Current Layer... ")
					(progn
						(command "LAYER" "FREEZE" (cdr (assoc 8(entget(car lrsi)))) "")
						(strp (cdr(assoc 8(entget(car lrsi)))))
					)
				)
			)
		)
		(progn
			(lrwrk)	
			(grtext)
		)
	)
	(setvar "blipmode" sblip) 
	(setvar "cmdecho" scmde)
	(setq *error* exerr)
	(prin1)
)
(prompt "\nCAD Ideas lisp routine is Loaded (C) Copyright Ed Azoyan.... Thank You ....   ")
(prin1)
